盛最多水的容器

题目

给定一个长度为 n 的整数数组 height 。有 n 条垂线,第 i 条线的两个端点是 (i, 0) 和 (i, height[i]) 。

找出其中的两条线,使得它们与 x 轴共同构成的容器可以容纳最多的水。

返回容器可以储存的最大水量。

说明: 你不能倾斜容器。

示例 1:

输入: 1,8,6,2,5,4,8,3,7

输出: 49

解释: 图中垂直线代表输入数组 1,8,6,2,5,4,8,3,7。在此情况下,容器能够容纳水(表示为蓝色部分)的最大值为 49。

示例 2:

输入: height = 1,1

输出: 1

提示:

  • n == height.length
  • 2 <= n <= 10的5次方
  • 0 <= height[i] <= 10的4次方

分析

容器存储水量的计算公式为:

长 = j - i

高 = min(heighti,heightj)

存储水量 = (j - i) * min(heighti,heightj)

第一步:寻找题目的可行解法

我们可以计算每一种可能的结果,然后取最大值即可

两次循环即可,此时的时间复杂度为O(N^2)

第二步:优化这个解法,减少不必要的计算

依据计算公式,可以知道存储水量由长和高来决定

  • 长:j - i越大,结果越大
  • 高:min(heighti,heightj)越大,结果越大

为了尽可能的获取最大值,我们可以先使长最大,此时结果的大小由高来决定

此时有三种情况:

  1. heighti > heightj,此时结果由短板heightj来决定

长变小的两种情况:

  • i++,此时短板heightj不变,所以min(heighti++,heightj) <= heightj,由于长变小,高不变或变小,所以结果变小,没有变大的可能
  • j--,此时heighti不变,heightj--相对于heightj,可能会变大,变小或不变,长变小,所以结果可能会变大,变小或不变,有变大的可能
  1. heighti < heightj,此时结果由短板heighti来决定

长变小的两种情况:

  • i++,此时heightj不变,heighti++相对于heighti,可能会变大,变小或不变,长变小,所以结果可能会变大,变小或不变,有变大的可能
  • j--,此时短板heighti不变,所以min(heighti,heightj--) <= heighti,由于长变小,高不变或变小,所以结果减小,没有变大的可能
  1. heighti = heightj,此时结果由heighti和heightj决定

长变小的两种情况:

  • i++,min(heighti++,heightj) <= heightj,长变小,高不变或变小,所以结果变小,没有变大的可能
  • j--,min(heighti,heightj--) <= heighti,长变小,高不变或变小,所以结果变小,没有变大的可能

整理思路:

  1. 找到最大的长,定义两个指针i = 0,j = len(height) - 1,记录当前结果
  2. 比较高的大小,当heighti > heightj时,移动短板的heightj才可能使结果变大,j--,移动后记录结果最大值
  3. 当heighti < heightj时,移动短板的heighti才可能使结果变大,i++,移动后记录结果最大值
  4. 当heighti = heightj时,移动i或j,结果都是变小,任意移动一个即可
  5. 当i >= j时,结束判断

代码

使用什么语言都无所谓,重点是理解思想

golang代码如下:

go 复制代码
func maxArea(height []int) int {
    var result int
    // 特殊判断
    if len(height) <= 1 {
        return result
    }

    // 定义两个指针
    i := 0
    j := len(height) - 1
    for i < j {
        // 长
        w := j - i
        // 高,默认值选择height[i]
        h := height[i]
        if height[i] > height[j] {
            // 当短板是height[j]时,使高等于短板
            h = height[j]
            // 移动短板对应的下标
            j--
        } else {
            // 短板是height[i]或height[i] = height[j],移动短板对应的下标
            i++
        }

        // 计算当前结果
        temp := h * w
        // 判断和保存结果最大值
        if temp > result {
            result = temp
        }
    }
    return result
}
  • 时间复杂度:O(N),双指针遍历数组
  • 空间复杂度:O(1),常量空间
相关推荐
吞下星星的少年·-·3 小时前
Div.3 CF 1131A题(排序,模拟)
算法·模拟·排序
圣保罗的大教堂4 小时前
leetcode 453. 最小操作次数使数组元素相等 中等
leetcode
aichitang20244 小时前
代数拓扑学与现代前沿视角
考研·算法·数学建模·ai·拓扑学·高考
二本咕咕-机械转码4 小时前
FreeRTOS深入解析(一)_链表与并发保护——哨兵循环链表、排序键游标、临界区与关调度
单片机·算法·链表
-银雾鸢尾-4 小时前
两数之和-C++实现
c++·算法
j7~4 小时前
【动态规划算法专题】动态规划五部曲实战:泰波那契数、三步问题、最小花费爬楼梯
c++·算法·动态规划·数据结构与算法
倍利福猎头公司官方账号5 小时前
大企业HR如何向猎头公司清晰传达AI岗位的技术需求?
人工智能·算法·机器人·求职招聘·业界资讯
揽星河..5 小时前
【C++】类和对象
c++·算法
D e re k ZH6 小时前
C++ 并发、未定义行为与工程化难点(No 3)
数据结构·c++·算法·面试